Attribute VB_Name = "ModMicroArt"
Option Explicit

Private hHlineDc&
Private hVlineDc&
Private hTileBmpOld&
Private hHlineBmpOld&
Private hVlineBmpOld&

Public HotX%
Public HotY%
Public hDtDc&
Public CellSize%
Public MaxExtent%
Public CaptureSize%
Public PasteOption%
Public Shell32Path$
Public MouseColors&(1)

Public TempFile$
Public ExtractFile$
Public ExtractIdx%
Public DialogFltrIdx%
Public bDirty As Boolean
Public bCancelled As Boolean
Public bMultiIcon As Boolean
Public bAdjustColors As Boolean

Public hPrevWndProc1&
Public hPrevWndProc2&
Public hPrevWndProc3&
Public hPrevWndProc4&
Public hPrevWndProc5&
Public hPrevWndProc6&
Public hPrevWndProc7&
Public hPrevWndProc8&
Public hPrevWndProc9&
Public hPrevWndProc10&
Public hPrevWndProc11&
Public hPrevWndProc12&

Public hTileDc&
Public hMaskDc&, hMaskBmp&, hMaskBmpOld&
Public hImageDc&, hImageBmp&, hImageBmpOld&

Type IconColors
     icRed As Integer
     icGreen As Integer
     icBlue As Integer
End Type

Public Defaults() As IconColors
Public EditVals() As IconColors
Public OutputVals() As IconColors

Type BITMAPFILEHEADER
     bfType As Integer
     bfSize As Long
     bfReserved1 As Integer
     bfReserved2 As Integer
     bfOffBits As Long
End Type

Type BITMAPINFOHEADER
     biSize As Long
     biWidth As Long
     biHeight As Long
     biPlanes As Integer
     biBitCount As Integer
     biCompression As Long
     biSizeImage As Long
     biXPelsPerMeter As Long
     biYPelsPerMeter As Long
     biClrUsed As Long
     biClrImportant As Long
End Type

Type CURSORDIR
     cdReserved As Integer
     cdType As Integer
     cdCount As Integer
End Type

Type CURSORDIRENTRY
     bWidth As Byte
     bHeight As Byte
     bColorCount As Byte
     bReserved As Byte
     wXHotspot As Integer
     wYHotspot As Integer
     dwBytesInRes As Long
     dwImageOffset As Long
End Type

Type ICONDIR
     idReserved As Integer
     idType As Integer
     idCount As Integer
End Type

Type ICONDIRENTRY
     bWidth As Byte
     bHeight As Byte
     bColorCount As Byte
     bReserved As Byte
     wPlanes As Integer
     wBitCount As Integer
     dwBytesInRes As Long
     dwImageOffset As Long
End Type

Type IconResourceInfo
     irIndex As Long
     irBitCount As Long
     irWidth As Long
     irHeight As Long
End Type

Public IRI As IconResourceInfo
Public IRI_TEST As IconResourceInfo

Type CHOOSECOLORSTRUCT
     lStructSize As Long
     hwndOwner As Long
     hInstance As Long
     rgbResult As Long
     lpCustColors As Long
     flags As Long
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As String
End Type

Type FILEINFO
     fiFileName As String
     fiFileTitle As String
     bSuccess As Boolean
End Type

Type OPENFILENAME
     lStructSize As Long
     hwndOwner As Long
     hInstance As Long
     lpstrFilter As String
     lpstrCustomFilter As String
     nMaxCustFilter As Long
     nFilterIndex As Long
     lpstrFile As String
     nMaxFile As Long
     lpstrFileTitle As String
     nMaxFileTitle As Long
     lpstrInitialDir As String
     lpstrTitle As String
     flags As Long
     nFileOffset As Integer
     nFileExtension As Integer
     lpstrDefExt As String
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As String
End Type

Type ICONPALETTE
     peBlue As Byte
     peGreen As Byte
     peRed As Byte
     peFlags As Byte
End Type

Type MONOPALETTE
     pBlue As Byte
     pGreen As Byte
     pRed As Byte
     pFlags As Byte
End Type

Public MP(1) As MONOPALETTE

Type PALETTE_16
     pBlue As Byte
     pGreen As Byte
     pRed As Byte
     pFlags As Byte
End Type

Public P16(15) As PALETTE_16

Type PALETTE_256
     pBlue As Byte
     pGreen As Byte
     pRed As Byte
     pFlags As Byte
End Type

Public P256(255) As PALETTE_256

Type POINTAPI
     Px As Long
     Py As Long
End Type

Type RECT
     rLeft As Long
     rTop As Long
     rRight As Long
     rBottom As Long
End Type

Type SHFILEINFO
     hIcon As Long
     iIcon As Long
     dwAttributes As Long
     szDisplayName As String * 260
     szTypeName As String * 80
End Type

Type LOGFONT
     lfHeight As Long
     lfWidth As Long
     lfEscapement As Long
     lfOrientation As Long
     lfWeight As Long
     lfItalic As Byte
     lfUnderline As Byte
     lfStrikeOut As Byte
     lfCharSet As Byte
     lfOutPrecision As Byte
     lfClipPrecision As Byte
     lfQuality As Byte
     lfPitchAndFamily As Byte
     lfFaceName(32) As Byte
End Type

Type NEWTEXTMETRIC
     tmHeight As Long
     tmAscent As Long
     tmDescent As Long
     tmInternalLeading As Long
     tmExternalLeading As Long
     tmAveCharWidth As Long
     tmMaxCharWidth As Long
     tmWeight As Long
     tmOverhang As Long
     tmDigitizedAspectX As Long
     tmDigitizedAspectY As Long
     tmFirstChar As Byte
     tmLastChar As Byte
     tmDefaultChar As Byte
     tmBreakChar As Byte
     tmItalic As Byte
     tmUnderlined As Byte
     tmStruckOut As Byte
     tmPitchAndFamily As Byte
     tmCharSet As Byte
     ntmFlags As Long
     ntmSizeEM As Long
     ntmCellHeight As Long
     ntmAveWidth As Long
End Type

Type SIZE
     sX As Long
     sY As Long
End Type

Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC&, ByVal x1&, ByVal y1&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDc&, ByVal xSrc&, ByVal ySrc&, ByVal dwRop&)
Declare Function CallWindowProc& Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc&, ByVal ahWnd&, ByVal Msg&, ByVal wParam&, ByVal lParam&)
Declare Function ChooseColor& Lib "comdlg32.dll" Alias "ChooseColorA" (lpChoosecolor As CHOOSECOLORSTRUCT)
Declare Function ClientToScreen& Lib "user32" (ByVal ahWnd&, lpPoint As POINTAPI)
Declare Function ClipCursor& Lib "user32" (lpRect As RECT)
Declare Function CreateCompatibleBitmap& Lib "gdi32" (ByVal ahDc&, ByVal nWidth&, ByVal nHeight&)
Declare Function CreateCompatibleDC& Lib "gdi32" (ByVal ahDc&)
Declare Function DeleteDC& Lib "gdi32" (ByVal ahDc&)
Declare Function DeleteObject& Lib "gdi32" (ByVal hObject&)
Declare Function DestroyIcon& Lib "user32" (ByVal hIcon&)
Declare Function DrawEdge& Lib "user32" (ByVal ahDc&, lpRect As RECT, ByVal nEdge&, ByVal nFlags&)
Declare Function DrawIconEx& Lib "user32" (ByVal ahDc&, ByVal xLeft&, ByVal yTop&, ByVal hIcon&, ByVal cxWidth&, ByVal cyWidth&, ByVal istepIfAniCur&, ByVal hbrFlickerFreeDraw&, ByVal diFlags&)
Declare Function DrawText& Lib "user32" Alias "DrawTextA" (ByVal ahDc&, ByVal lpStr$, ByVal nCount&, lpRect As RECT, ByVal wFormat&)
Declare Function Ellipse& Lib "gdi32" (ByVal ahDc&, ByVal x1&, ByVal y1&, ByVal x2&, ByVal y2&)
Declare Function EnumFontFamilies& Lib "gdi32" Alias "EnumFontFamiliesA" (ByVal ahDc&, ByVal lpszFamily$, ByVal lpEnumFontFamProc&, lParam As Any)
Declare Function ExtFloodFill& Lib "gdi32" (ByVal ahDc&, ByVal x1&, ByVal y1&, ByVal crColor&, ByVal wFillType&)
Declare Function ExtractIconEx& Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile$, ByVal nIconIndex&, phiconLarge&, phiconSmall&, ByVal nIcons&)
Declare Function FreeCursor& Lib "user32" Alias "ClipCursor" (ByVal Zero&)
Declare Function GetDC& Lib "user32" (ByVal ahWnd&)
Declare Function GetDesktopWindow& Lib "user32" ()
Declare Function GetDeviceCaps& Lib "gdi32" (ByVal ahDc&, ByVal nIndex&)
Declare Function GetOpenFileName& Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME)
Declare Function GetPixel& Lib "gdi32" (ByVal ahDc&, ByVal x1&, ByVal y1&)
Declare Function GetSaveFileName& Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME)
Declare Function GetSystemDirectory& Lib "kernel32" Alias "GetSystemDirectoryA" (ByVal lpBuffer$, ByVal nSize&)
Declare Function GetSystemMetrics& Lib "user32" (ByVal nIndex&)
Declare Function GetTempPath& Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength&, ByVal lpBuffer$)
Declare Function GetTextExtentPoint32& Lib "gdi32" Alias "GetTextExtentPoint32A" (ByVal ahDc&, ByVal lpsz$, ByVal cbString&, lpSize As SIZE)
Declare Function ReleaseDC& Lib "user32" (ByVal ahWnd&, ByVal ahDc&)
Declare Function SelectObject& Lib "gdi32" (ByVal ahDc&, ByVal hObject&)
Declare Function SetPixelV& Lib "gdi32" (ByVal ahDc&, ByVal x1&, ByVal y1&, ByVal crColor&)
Declare Function SetRect& Lib "user32" (lpRect As RECT, ByVal x1&, ByVal y1&, ByVal x2&, ByVal y2&)
Declare Function SetStretchBltMode& Lib "gdi32" (ByVal ahDc&, ByVal nStretchMode&)
Declare Function SetWindowLong& Lib "user32" Alias "SetWindowLongA" (ByVal ahWnd&, ByVal nIndex&, ByVal dwNewLong&)
Declare Function SHGetFileInfo& Lib "shell32.dll" Alias "SHGetFileInfoA" (ByVal pszPath$, ByVal dwFileAttributes&, psfi As SHFILEINFO, ByVal cbFileInfo&, ByVal uFlags&)
Declare Function StretchBlt& Lib "gdi32" (ByVal ahDc&, ByVal x1&, ByVal y1&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDc&, ByVal xSrc&, ByVal ySrc&, ByVal nSrcWidth&, ByVal nSrcHeight&, ByVal dwRop&)

Public Const BITSPIXEL = 12

Public Const MAX_PATH = 260
Public Const MAX_FILE = 256

Public Const GWL_WNDPROC = (-4)
Public Const WM_SETFOCUS = &H7

Public Const DI_MASK = 1
Public Const DI_IMAGE = 2
Public Const DI_NORMAL = 3

Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800

Public Const SHGFI_DISPLAYNAME = &H200
Private Sub Main()

    #If Win32 Then
        If Not ColorModeOk Then End
        PrepPalettes
        GetShell32Path
        CreateTempFileName
        SetUpIconDblClick
        FrmMicroArt.Show
    #Else
        End
    #End If

End Sub
Private Function ColorModeOk() As Boolean

    Dim Msg$

    If GetDeviceCaps(GetDC(0), BITSPIXEL) > 8 Then
       ColorModeOk = True
    Else
       Msg = "MicroArt Requires At Least High Color Mode In Order To Function."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & "Please Adjust Your Color Mode And Try Again."
       MsgBox Msg, vbCritical, "MicroArt - Error"
       ColorModeOk = False
    End If

End Function
Private Sub GetShell32Path()

    Dim SysDir$
    Dim NumChars&

    SysDir = Space(MAX_PATH)
    NumChars = GetSystemDirectory(SysDir, MAX_PATH)
    SysDir = Left(SysDir, NumChars)

    Shell32Path = SysDir & "\Shell32.dll"

End Sub
Private Sub CreateTempFileName()

    Dim Rv&
    Dim Buffer$

    Buffer = Space(MAX_PATH)
    Rv = GetTempPath(MAX_PATH, Buffer)
    TempFile = Left(Buffer, Rv) & "Abcdwxyz.ico"

End Sub
Public Sub GetFonts(CB As ComboBox)

    Dim Dc&

    CB.Clear
    Dc = GetDC(CB.hWnd)
    EnumFontFamilies Dc, vbNullString, AddressOf EnumFontFamProc, CB
    ReleaseDC CB.hWnd, Dc

End Sub
Public Function EnumFontFamProc&(LF As LOGFONT, NTM As NEWTEXTMETRIC, ByVal FontType&, lParam As ComboBox)

    Dim FontName$

    FontName = StrConv(LF.lfFaceName, vbUnicode)
    lParam.AddItem Left(FontName, InStr(FontName, vbNullChar) - 1)
    EnumFontFamProc = 1

End Function
Public Sub PositionForm(Frm As Form)

    With Frm
        .Move (Screen.Width - .Width) \ 2, (Screen.Height - .Height) \ 3
    End With

End Sub
Public Sub CreateTile()

    hTileDc = CreateCompatibleDC(0)
    hTileBmpOld = SelectObject(hTileDc, LoadResPicture(30, 0))

End Sub
Public Sub DeleteTile()

    DeleteObject SelectObject(hTileDc, hTileBmpOld)
    DeleteDC hTileDc

End Sub
Public Sub CreateLines()

    hHlineDc = CreateCompatibleDC(0)
    hHlineBmpOld = SelectObject(hHlineDc, LoadResPicture(10, 0))

    hVlineDc = CreateCompatibleDC(0)
    hVlineBmpOld = SelectObject(hVlineDc, LoadResPicture(20, 0))

End Sub
Public Sub DeleteLines()

    DeleteObject SelectObject(hHlineDc, hHlineBmpOld)
    DeleteDC hHlineDc

    DeleteObject SelectObject(hVlineDc, hVlineBmpOld)
    DeleteDC hVlineDc

End Sub
Public Sub TilePicMainCopy()

    Dim Dc&
    Dim W%, H%
    Dim Dx%, Dy%
    Dim BlitSize%

    With FrmMicroArt.PicMainCopy
        .Cls
         Dc = .hDC
         W = .ScaleWidth - 1
         H = .ScaleHeight - 1
    End With

    BlitSize = CellSize - 2

    For Dy = 1 To H Step CellSize
        For Dx = 1 To W Step CellSize
            BitBlt Dc, Dx, Dy, BlitSize, BlitSize, hTileDc, 0, 0, vbSrcCopy
        Next
    Next

End Sub
Public Sub DrawGrid()

    Dim Dc&, K%

    Dc = FrmMicroArt.PicMain.hDC

    For K = 0 To 385 Step CellSize
        BitBlt Dc, 0, K, 385, 1, hHlineDc, 0, 0, vbSrcCopy
        BitBlt Dc, K, 0, 1, 385, hVlineDc, 0, 0, vbSrcCopy
    Next

    FrmMicroArt.PicMain.Refresh

End Sub
Public Sub UpdatePicMain()

    With FrmMicroArt
         BitBlt .PicMain.hDC, 0, 0, 384, 384, .PicMainCopy.hDC, 0, 0, vbSrcCopy
    End With

    DrawGrid

End Sub
Public Sub InitMouseColors()

    MouseColors(0) = &H0&
    MouseColors(1) = &HFFFFFF

    With FrmMicroArt
        .PicLeft.Cls
        .PicLeft.BackColor = &H0&
        .PicRight.Cls
        .PicRight.BackColor = &HFFFFFF
    End With

End Sub
Public Sub AdjustToEdge(P%, Q%)

    P = (P \ CellSize) * CellSize
    Q = (Q \ CellSize) * CellSize

End Sub
Public Sub AdjustToCentre(P%, Q%)

    P = (P \ CellSize) * CellSize + (CellSize \ 2)
    Q = (Q \ CellSize) * CellSize + (CellSize \ 2)

End Sub
Public Sub ConfineCoords(P%, Q%)

    If P < 0 Then P = 0
    If P > 384 Then P = 384
    If Q < 0 Then Q = 0
    If Q > 384 Then Q = 384

End Sub
Public Sub SwapVals(A%, B%)

    Dim Temp%

    Temp = A
    A = B
    B = Temp

End Sub
Public Sub SubClassControls()

    With FrmMicroArt
         hPrevWndProc1 = SetWindowLong(.OptTool(0).hWnd, GWL_WNDPROC, AddressOf MsgProc1)
         hPrevWndProc2 = SetWindowLong(.OptTool(1).hWnd, GWL_WNDPROC, AddressOf MsgProc2)
         hPrevWndProc3 = SetWindowLong(.OptTool(2).hWnd, GWL_WNDPROC, AddressOf MsgProc3)
         hPrevWndProc4 = SetWindowLong(.OptTool(3).hWnd, GWL_WNDPROC, AddressOf MsgProc4)
         hPrevWndProc5 = SetWindowLong(.OptTool(4).hWnd, GWL_WNDPROC, AddressOf MsgProc5)
         hPrevWndProc6 = SetWindowLong(.OptTool(5).hWnd, GWL_WNDPROC, AddressOf MsgProc6)
         hPrevWndProc7 = SetWindowLong(.OptTool(6).hWnd, GWL_WNDPROC, AddressOf MsgProc7)
         hPrevWndProc8 = SetWindowLong(.OptTool(7).hWnd, GWL_WNDPROC, AddressOf MsgProc8)
         hPrevWndProc9 = SetWindowLong(.OptTool(8).hWnd, GWL_WNDPROC, AddressOf MsgProc9)
         hPrevWndProc10 = SetWindowLong(.OptTool(9).hWnd, GWL_WNDPROC, AddressOf MsgProc10)
         hPrevWndProc11 = SetWindowLong(.OptTool(10).hWnd, GWL_WNDPROC, AddressOf MsgProc11)
         hPrevWndProc12 = SetWindowLong(.OptTool(11).hWnd, GWL_WNDPROC, AddressOf MsgProc12)
    End With

End Sub
Public Function MsgProc1&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc1 = 0
     Else
        MsgProc1 = CallWindowProc(hPrevWndProc1, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc2&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc2 = 0
     Else
        MsgProc2 = CallWindowProc(hPrevWndProc2, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc3&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc3 = 0
     Else
        MsgProc3 = CallWindowProc(hPrevWndProc3, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc4&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc4 = 0
     Else
        MsgProc4 = CallWindowProc(hPrevWndProc4, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc5&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc5 = 0
     Else
        MsgProc5 = CallWindowProc(hPrevWndProc5, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc6&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc6 = 0
     Else
        MsgProc6 = CallWindowProc(hPrevWndProc6, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc7&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc7 = 0
     Else
        MsgProc7 = CallWindowProc(hPrevWndProc7, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc8&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc8 = 0
     Else
        MsgProc8 = CallWindowProc(hPrevWndProc8, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc9&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc9 = 0
     Else
        MsgProc9 = CallWindowProc(hPrevWndProc9, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc10&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc10 = 0
     Else
        MsgProc10 = CallWindowProc(hPrevWndProc10, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc11&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc11 = 0
     Else
        MsgProc11 = CallWindowProc(hPrevWndProc11, hw, umsg, wParam, lParam)
     End If

End Function
Public Function MsgProc12&(ByVal hw&, ByVal umsg&, ByVal wParam&, ByVal lParam&)

     If umsg = WM_SETFOCUS Then
        MsgProc12 = 0
     Else
        MsgProc12 = CallWindowProc(hPrevWndProc12, hw, umsg, wParam, lParam)
     End If

End Function
Public Sub UnSubClassControls()

    With FrmMicroArt
         SetWindowLong .OptTool(0).hWnd, GWL_WNDPROC, hPrevWndProc1
         SetWindowLong .OptTool(1).hWnd, GWL_WNDPROC, hPrevWndProc2
         SetWindowLong .OptTool(2).hWnd, GWL_WNDPROC, hPrevWndProc3
         SetWindowLong .OptTool(3).hWnd, GWL_WNDPROC, hPrevWndProc4
         SetWindowLong .OptTool(4).hWnd, GWL_WNDPROC, hPrevWndProc5
         SetWindowLong .OptTool(5).hWnd, GWL_WNDPROC, hPrevWndProc6
         SetWindowLong .OptTool(6).hWnd, GWL_WNDPROC, hPrevWndProc7
         SetWindowLong .OptTool(7).hWnd, GWL_WNDPROC, hPrevWndProc8
         SetWindowLong .OptTool(8).hWnd, GWL_WNDPROC, hPrevWndProc9
         SetWindowLong .OptTool(9).hWnd, GWL_WNDPROC, hPrevWndProc10
         SetWindowLong .OptTool(10).hWnd, GWL_WNDPROC, hPrevWndProc11
         SetWindowLong .OptTool(11).hWnd, GWL_WNDPROC, hPrevWndProc12
    End With

End Sub
