Attribute VB_Name = "ModMicroArtFileIO"
Option Explicit

Private MaskArray() As Byte
Private ImageArray() As Byte

Private IP() As ICONPALETTE
Public Function GetFileName(hOwner&, DialogType%) As FILEINFO

    Dim Rv&
    Dim OFN As OPENFILENAME

    With OFN
         Select Case DialogType
                Case 1
                    .lpstrTitle = "MicroArt - Open"
                    .flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
                    .lpstrDefExt = ""
                    .lpstrFilter = "Windows Icon (*.ico)" & vbNullChar & "*.ico" & vbNullChar & vbNullChar
                    .nFilterIndex = 1
                Case 2
                    .lpstrTitle = "MicroArt - Save As"
                    .flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
                    .lpstrDefExt = ".ico"
                    .lpstrFilter = "Windows Icon (*.ico)" & vbNullChar & "*.ico" & vbNullChar & vbNullChar
                    .nFilterIndex = 1
                Case 3
                    .lpstrTitle = "MicroArt - Save As Bitmap"
                    .flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
                    .lpstrDefExt = ".bmp"
                    .lpstrFilter = "Windows Bitmap (*.bmp)" & vbNullChar & "*.bmp" & vbNullChar & vbNullChar
                    .nFilterIndex = 1
                Case 4
                    .lpstrTitle = "MicroArt - Save As Cursor"
                    .flags = OFN_PATHMUSTEXIST Or OFN_HIDEREADONLY Or OFN_OVERWRITEPROMPT
                    .lpstrDefExt = ".cur"
                    .lpstrFilter = "Windows Cursor (*.cur)" & vbNullChar & "*.cur" & vbNullChar & vbNullChar
                    .nFilterIndex = 1
                Case 5
                    .lpstrTitle = "MicroArt - Extract Icon"
                    .flags = OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
                    .lpstrDefExt = ""
                    .lpstrFilter = "ActiveX Control (*.ocx)" & vbNullChar & "*.ocx" & vbNullChar
                    .lpstrFilter = .lpstrFilter & "Animated Cursor (*.ani)" & vbNullChar & "*.ani" & vbNullChar
                    .lpstrFilter = .lpstrFilter & "Dynamic Link Library (*.dll)" & vbNullChar & "*.dll" & vbNullChar
                    .lpstrFilter = .lpstrFilter & "Executable (*.exe)" & vbNullChar & "*.exe" & vbNullChar
                    .lpstrFilter = .lpstrFilter & "Icon Library (*.icl)" & vbNullChar & "*.icl" & vbNullChar
                    .lpstrFilter = .lpstrFilter & "All Files (*.*)" & vbNullChar & "*.*" & vbNullChar & vbNullChar
                    .nFilterIndex = DialogFltrIdx
         End Select
        .lStructSize = Len(OFN)
        .hwndOwner = hOwner
        .hInstance = App.hInstance
        .lpstrFile = String(MAX_PATH, 0)
        .lpstrFileTitle = String(MAX_FILE, 0)
        .nMaxFile = MAX_PATH
        .nMaxFileTitle = MAX_FILE
    End With

    Select Case DialogType
           Case 1, 5
                Rv = GetOpenFileName(OFN)
           Case 2 To 4
                Rv = GetSaveFileName(OFN)
    End Select

    DoEvents

    If Rv = 1 Then
       If DialogType = 5 Then DialogFltrIdx = OFN.nFilterIndex
       With GetFileName
           .fiFileName = Left(OFN.lpstrFile, InStr(OFN.lpstrFile, vbNullChar) - 1)
           .fiFileTitle = Left(OFN.lpstrFileTitle, InStr(OFN.lpstrFileTitle, vbNullChar) - 1)
           .bSuccess = True
       End With
    End If

End Function
Public Function ValidIcon(FName$) As Boolean

    Dim F%
    Dim ID As ICONDIR
    Dim IDE As ICONDIRENTRY
    Dim bFileOpen As Boolean

    On Error GoTo OpenError

    F = FreeFile
    Open FName For Binary Access Read As #F
         bFileOpen = True
         Get #F, 1, ID
         Get #F, 7, IDE
    Close #F
    bFileOpen = False

    If ID.idCount <= 0 Then
       ValidIcon = False
       Exit Function
    End If

    If ID.idReserved <> 0 Then
       ValidIcon = False
       Exit Function
    End If

    If ID.idType <> 1 Then
       ValidIcon = False
       Exit Function
    End If

    If IDE.bReserved <> 0 Then
       ValidIcon = False
       Exit Function
    End If

    If IDE.bHeight = 0 Then
       ValidIcon = False
       Exit Function
    End If

    If IDE.bWidth = 0 Then
       ValidIcon = False
       Exit Function
    End If

    If IDE.dwBytesInRes <= 0 Then
       ValidIcon = False
       Exit Function
    End If

    If IDE.dwImageOffset <= 0 Then
       ValidIcon = False
       Exit Function
    End If

    ValidIcon = True
    On Error GoTo 0
    Exit Function

OpenError:

    Err.Clear
    If bFileOpen Then Close #F
    ValidIcon = False
    On Error GoTo 0
    Exit Function

End Function
Public Function EnumIconsInFile&(FName$)

    Dim F%
    Dim ID As ICONDIR
    Dim bFileOpen As Boolean

    On Error GoTo EnumError

    F = FreeFile
    Open FName For Binary Access Read As #F
         bFileOpen = True
         Get #F, 1, ID
    Close #F
    bFileOpen = False

    If ID.idCount > 0 Then
       EnumIconsInFile = ID.idCount
    Else
       EnumIconsInFile = 0
    End If

    On Error GoTo 0
    Exit Function

EnumError:

    Err.Clear
    If bFileOpen Then Close #F
    EnumIconsInFile = 0
    On Error GoTo 0
    Exit Function

End Function
Public Function LoadIconFromFile(FName$) As Boolean

    Dim F%
    Dim Msg$
    Dim W&, H&
    Dim IDE As ICONDIRENTRY
    Dim BIH As BITMAPINFOHEADER
    Dim bFileOpen As Boolean
    Dim bBadDims As Boolean

    On Error GoTo LoadError

    F = FreeFile
    Open FName For Binary Access Read As #F
         bFileOpen = True
         Get #F, 7, IDE
         Get #F, IDE.dwImageOffset + 1, BIH
    Close #F
    bFileOpen = False

    W = BIH.biWidth
    H = BIH.biHeight \ 2

    Select Case W
           Case 16, 32, 48
           Case Else
                bBadDims = True
    End Select

    Select Case H
           Case 16, 32, 48
           Case Else
                bBadDims = True
    End Select

    If W <> H Then bBadDims = True

    If bBadDims Then
       Msg = "Icon has dimensions which are incompatible with MicroArt."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & CStr(W) & " x " & CStr(H) & " pixels."
       MsgBox Msg, vbExclamation, "MicroArt - Error"
       LoadIconFromFile = False
       Exit Function
    End If

    FrmMicroArt.PicLoad.Picture = LoadPicture(FName)

    LoadIconFromFile = True
    On Error GoTo 0
    Exit Function

LoadError:

    Err.Clear

    Msg = "An unexpected error occurred while loading the icon."
    MsgBox Msg, vbExclamation, "MicroArt - Error"

    If bFileOpen Then Close #F
    LoadIconFromFile = False
    On Error GoTo 0
    Exit Function

End Function
Public Function PresentMultiIconDialog(FName$, NumIcons&) As Boolean

    Dim F%, K&
    Dim Bits&
    Dim IcoInfo$
    Dim bFileOpen As Boolean
    Dim IDE As ICONDIRENTRY
    Dim BIH As BITMAPINFOHEADER

    On Error GoTo DialogError

    NumIcons = NumIcons - 1

    F = FreeFile
    Open FName For Binary Access Read As #F
         bFileOpen = True
         For K = 0 To NumIcons
             Get #F, (K * 16) + 7, IDE
             Get #F, IDE.dwImageOffset + 1, BIH
             IcoInfo = CStr(BIH.biWidth) & " x " & CStr(BIH.biHeight \ 2)
             Select Case BIH.biBitCount
                    Case 1: IcoInfo = IcoInfo & " ... Monochrome": Bits = 1
                    Case 4: IcoInfo = IcoInfo & " ... 16 Color": Bits = 4
                    Case 8: IcoInfo = IcoInfo & " ... 256 Color": Bits = 8
                 Case Else: IcoInfo = IcoInfo & " ... True Color": Bits = 24
             End Select
             FrmMultiIconDialog.LstIcons.AddItem IcoInfo
             FrmMultiIconDialog.LstIcons.ItemData(FrmMultiIconDialog.LstIcons.NewIndex) = Bits
             IcoInfo = ""
         Next
         FrmMultiIconDialog.LstIcons.Selected(0) = True
    Close #F
    bFileOpen = False

    On Error GoTo 0
    PresentMultiIconDialog = True
    Exit Function

DialogError:

     Err.Clear
     On Error GoTo 0

     If bFileOpen Then Close #F
     PresentMultiIconDialog = False

     On Error Resume Next
        Unload FrmMultiIconDialog
        If Err.Number Then Err.Clear
     On Error GoTo 0

     Exit Function

End Function
Public Function LoadIconResource(FName$) As Boolean

    Dim Msg$
    Dim F%, Ub&
    Dim W&, H&
    Dim Dx%, Dy%
    Dim PaletteSize%
    Dim IconType%
    Dim bFileOpen As Boolean
    Dim IDE As ICONDIRENTRY
    Dim bBadDims As Boolean

    W = IRI_TEST.irWidth
    H = IRI_TEST.irHeight

    Select Case W
           Case 16, 32, 48
           Case Else
                bBadDims = True
    End Select

    Select Case H
           Case 16, 32, 48
           Case Else
                bBadDims = True
    End Select

    If W <> H Then bBadDims = True

    If bBadDims Then
       Msg = "Icon has dimensions which are incompatible with MicroArt."
       Msg = Msg & vbCrLf & vbCrLf
       Msg = Msg & CStr(W) & " x " & CStr(H) & " pixels."
       MsgBox Msg, vbExclamation, "MicroArt - Error"
       LoadIconResource = False
       Exit Function
    End If

    Select Case IRI_TEST.irBitCount
           Case 1: PaletteSize = 8: ReDim IP(1)
           Case 4: PaletteSize = 64: ReDim IP(15)
           Case 8: PaletteSize = 1024: ReDim IP(255)
        Case Else: PaletteSize = 0
    End Select

    Select Case IRI_TEST.irWidth
           Case 16: ReDim MaskArray(63)
           Case 32: ReDim MaskArray(127)
           Case 48: ReDim MaskArray(383)
    End Select

    Select Case IRI_TEST.irWidth
           Case 16
                ReDim MaskArray(63)
                Select Case IRI_TEST.irBitCount
                       Case 1: ReDim ImageArray(63): IconType = 1
                       Case 4: ReDim ImageArray(127): IconType = 2
                       Case 8: ReDim ImageArray(255): IconType = 3
                    Case Else: ReDim ImageArray(767): IconType = 4
                End Select
           Case 32
                ReDim MaskArray(127)
                Select Case IRI_TEST.irBitCount
                       Case 1: ReDim ImageArray(127): IconType = 5
                       Case 4: ReDim ImageArray(511): IconType = 6
                       Case 8: ReDim ImageArray(1023): IconType = 7
                    Case Else: ReDim ImageArray(3071): IconType = 8
                End Select
           Case 48
                ReDim MaskArray(383)
                Select Case IRI_TEST.irBitCount
                       Case 1: ReDim ImageArray(383): IconType = 9
                       Case 4: ReDim ImageArray(1151): IconType = 10
                       Case 8: ReDim ImageArray(2303): IconType = 11
                    Case Else: ReDim ImageArray(6911): IconType = 12
                End Select
    End Select

    On Error GoTo ResourceError

    Ub = UBound(ImageArray)
    F = FreeFile
    Open FName For Binary Access Read As #F
         bFileOpen = True
         Get #F, (16 * IRI_TEST.irIndex) + 7, IDE

         If PaletteSize > 0 Then
            Get #F, (IDE.dwImageOffset + 1) + 40, IP()
         End If

         Get #F, (IDE.dwImageOffset + 1) + 40 + PaletteSize, ImageArray()
         Get #F, (IDE.dwImageOffset + 1) + 40 + PaletteSize + (Ub + 1), MaskArray()
    Close #F
    bFileOpen = False

    hMaskDc = CreateCompatibleDC(0)
    hMaskBmp = CreateCompatibleBitmap(hMaskDc, W, H)
    hMaskBmpOld = SelectObject(hMaskDc, hMaskBmp)

    hImageDc = CreateCompatibleDC(0)
    hImageBmp = CreateCompatibleBitmap(FrmMicroArt.PicImage.hDC, W, H)
    hImageBmpOld = SelectObject(hImageDc, hImageBmp)

    Select Case IRI_TEST.irWidth
           Case 16: CreateMask 15, 15, 2
           Case 32: CreateMask 31, 31, 0
           Case 48: CreateMask 47, 47, 2
    End Select

    Select Case IconType
           Case 1: CreateMonochromeIcon 15, 15, 2
           Case 2: Create16ColorIcon 15, 15
           Case 3: Create256ColorIcon 15, 15
           Case 4: CreateTrueColorIcon 15, 15

           Case 5: CreateMonochromeIcon 31, 31, 0
           Case 6: Create16ColorIcon 31, 31
           Case 7: Create256ColorIcon 31, 31
           Case 8: CreateTrueColorIcon 31, 31

           Case 9: CreateMonochromeIcon 47, 47, 2
          Case 10: Create16ColorIcon 47, 47
          Case 11: Create256ColorIcon 47, 47
          Case 12: CreateTrueColorIcon 47, 47
    End Select

    LoadIconResource = True
    On Error GoTo 0
    Exit Function

ResourceError:

    Err.Clear
    If bFileOpen Then Close #F
    On Error GoTo 0

    Msg = "An unexpected error occurred while loading the icon resource."
    MsgBox Msg, vbExclamation, "MicroArt - Error"

    DeleteTempObjects

    LoadIconResource = False
    Exit Function

End Function
Public Sub DeleteTempObjects()

    If hMaskDc <> 0 Then
       DeleteObject SelectObject(hMaskDc, hMaskBmpOld)
       DeleteDC hMaskDc
       hMaskDc = 0
    End If

    If hImageDc <> 0 Then
       DeleteObject SelectObject(hImageDc, hImageBmpOld)
       DeleteDC hImageDc
       hImageDc = 0
    End If

End Sub
Private Sub CreateMask(W%, H%, Adjustment%)

    Dim Dx%, Dy%
    Dim Bs$, K%, N%, P&

    For Dy = H To 0 Step -1
        For Dx = 0 To W Step 8
            Bs = ConvertTo8BitBinary(MaskArray(K + P))
            For N = 1 To 8
                If Mid(Bs, N, 1) = "0" Then
                   SetPixelV hMaskDc, Dx + (N - 1), Dy, &H0&
                Else
                   SetPixelV hMaskDc, Dx + (N - 1), Dy, &HFFFFFF
                End If
            Next
            K = K + 1
        Next
        P = P + Adjustment
    Next

End Sub
Private Sub CreateMonochromeIcon(W%, H%, Adjustment%)

    Dim Dx%, Dy%
    Dim Bs$, K%, N%, P&

    For Dy = H To 0 Step -1
        For Dx = 0 To W Step 8
            Bs = ConvertTo8BitBinary(ImageArray(K + P))
            For N = 1 To 8
                If Mid(Bs, N, 1) = "0" Then
                   With IP(0)
                        SetPixelV hImageDc, Dx + (N - 1), Dy, RGB(.peRed, .peGreen, .peBlue)
                   End With
                Else
                   With IP(1)
                        SetPixelV hImageDc, Dx + (N - 1), Dy, RGB(.peRed, .peGreen, .peBlue)
                   End With
                End If
            Next
            K = K + 1
        Next
        P = P + Adjustment
    Next

End Sub
Private Sub Create16ColorIcon(W%, H%)

    Dim Bs$, K%
    Dim Dx%, Dy%
    Dim Idx1%, Idx2%

    For Dy = H To 0 Step -1
        For Dx = 0 To W Step 2
            Bs = ConvertTo8BitBinary(ImageArray(K))
            Idx1 = GetFirstFourBits(Bs)
            Idx2 = GetLastFourBits(Bs)
            With IP(Idx1)
                 SetPixelV hImageDc, Dx, Dy, RGB(.peRed, .peGreen, .peBlue)
            End With
            With IP(Idx2)
                 SetPixelV hImageDc, Dx + 1, Dy, RGB(.peRed, .peGreen, .peBlue)
            End With
            K = K + 1
        Next
    Next

End Sub
Private Sub Create256ColorIcon(W%, H%)

    Dim Dx%, Dy%, K%

    For Dy = H To 0 Step -1
        For Dx = 0 To W
            With IP(ImageArray(K))
                 SetPixelV hImageDc, Dx, Dy, RGB(.peRed, .peGreen, .peBlue)
            End With
            K = K + 1
        Next
    Next

End Sub
Private Sub CreateTrueColorIcon(W%, H%)

    Dim K%
    Dim Dx%, Dy%

    For Dy = H To 0 Step -1
        For Dx = 0 To W
            SetPixelV hImageDc, Dx, Dy, RGB(ImageArray(K + 2), ImageArray(K + 1), ImageArray(K))
            K = K + 3
        Next
    Next

End Sub
Private Function ConvertTo8BitBinary$(B As Byte)

    Dim K%
    Dim BinStr$

    For K = 1 To 8
        If B Mod 2 Then BinStr = "1" & BinStr Else BinStr = "0" & BinStr
        B = B \ 2
    Next

    ConvertTo8BitBinary = BinStr

End Function
Private Function GetFirstFourBits(Bs) As Byte

    Dim K%
    Dim B As Byte

    For K = 1 To 4
        If Mid(Bs, K, 1) = "1" Then B = B + 2 ^ (4 - K)
    Next

    GetFirstFourBits = B

End Function
Private Function GetLastFourBits(Bs) As Byte

    Dim K%
    Dim B As Byte

    For K = 1 To 4
        If Mid(Bs, K + 4, 1) = "1" Then B = B + 2 ^ (4 - K)
    Next

    GetLastFourBits = B

End Function
Public Function SaveAsBmp(Pic As PictureBox, NumColors&, FName$) As Boolean

    Dim F%
    Dim bFileOpen As Boolean
    Dim BFH As BITMAPFILEHEADER
    Dim BIH As BITMAPINFOHEADER

    With BFH
        .bfType = 19778
        .bfReserved1 = 0
        .bfReserved2 = 0
         Select Case NumColors
                Case 2: .bfOffBits = 62
               Case 16: .bfOffBits = 118
              Case 256: .bfOffBits = 1078
             Case Else: .bfOffBits = 54
         End Select
         Select Case Pic.Width
                Case 16
                     Select Case NumColors
                            Case 2: .bfSize = 126
                           Case 16: .bfSize = 246
                          Case 256: .bfSize = 1334
                         Case Else: .bfSize = 822
                     End Select
                Case 32
                     Select Case NumColors
                            Case 2: .bfSize = 190
                           Case 16: .bfSize = 630
                          Case 256: .bfSize = 2102
                         Case Else: .bfSize = 3126
                     End Select
                Case 48
                     Select Case NumColors
                            Case 2: .bfSize = 446
                           Case 16: .bfSize = 1270
                          Case 256: .bfSize = 3382
                         Case Else: .bfSize = 6966
                     End Select
         End Select
    End With

    With BIH
         Select Case NumColors
                Case 2
                    .biBitCount = 1
                    .biSizeImage = ((((Pic.Width + 7) \ 8) + 3) And &HFFFFFFFC) * Pic.Height
               Case 16
                    .biBitCount = 4
                    .biSizeImage = ((((Pic.Width + 1) \ 2) + 3) And &HFFFFFFFC) * Pic.Height
              Case 256
                    .biBitCount = 8
                    .biSizeImage = ((Pic.Width + 3) And &HFFFFFFFC) * Pic.Height
             Case Else
                    .biBitCount = 24
                    .biSizeImage = ((Pic.Width * 3 + 3) And &HFFFFFFFC) * Pic.Height
         End Select
        .biClrImportant = 0
        .biClrUsed = 0
        .biCompression = 0
        .biHeight = Pic.Height
        .biPlanes = 1
        .biSize = Len(BIH)
        .biWidth = Pic.Width
        .biXPelsPerMeter = 0
        .biYPelsPerMeter = 0
    End With

    On Error Resume Next
       Kill FName
       If Err.Number Then Err.Clear
    On Error GoTo 0

    On Error GoTo SaveBmpError
       F = FreeFile
       Open FName For Binary Access Write As #F
            bFileOpen = True
            Put #F, , BFH
            Put #F, , BIH
            Select Case BIH.biBitCount
                   Case 1
                        Put #F, , MP()
                        AddMonochromeData Pic, F
                   Case 4
                        Put #F, , P16()
                        Add16ColorData Pic, F
                   Case 8
                        Create256PaletteForBitmap Pic
                        Put #F, , P256()
                        Add256ColorData Pic, F
                   Case 24
                        AddTrueColorData Pic, F
            End Select
       Close #F
       bFileOpen = False
    On Error GoTo 0

    SaveAsBmp = True
    Exit Function

SaveBmpError:

    Err.Clear
    If bFileOpen Then Close #F
    SaveAsBmp = False
    Exit Function

End Function
Private Sub AddMonochromeData(Pic As PictureBox, F%)

    Dim K%
    Dim C&, Dc&
    Dim Dx%, Dy%
    Dim pW%, pH%
    Dim Bs$, Pad%

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    For Dy = pH To 0 Step -1
        For Dx = 0 To pW Step 8
            For K = 0 To 7
                C = GetPixel(Dc, Dx + K, Dy)
                If C = &HFFFFFF Then Bs = Bs & "1" Else Bs = Bs & "0"
                If Len(Bs) = 8 Then
                   Put #F, , CreateMonoByte(Bs)
                   Bs = ""
                End If
            Next
        Next
        If pW <> 31 Then Put #F, , Pad
    Next

End Sub
Private Function CreateMonoByte(Bs$) As Byte

    Dim K%
    Dim B As Byte

    For K = 1 To 8
        If Mid(Bs, K, 1) = "1" Then B = B + 2 ^ (8 - K)
    Next

    CreateMonoByte = B

End Function
Private Sub Add16ColorData(Pic As PictureBox, F%)

    Dim Dc&, K%
    Dim C&
    Dim Dx%, Dy%
    Dim pW%, pH%
    Dim R&, G&, B&
    Dim Idx1%, Idx2%

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    For Dy = pH To 0 Step -1
        For Dx = 0 To pW Step 2
            C = GetPixel(Dc, Dx, Dy)
            B = C \ 65536
            G = (C - B * 65536) \ 256
            R = C - B * 65536 - G * 256
            For K = 0 To 15
                With P16(K)
                     If B = .pBlue And G = .pGreen And R = .pRed Then
                        Idx1 = K
                        Exit For
                     End If
                End With
            Next
            C = GetPixel(Dc, Dx + 1, Dy)
            B = C \ 65536
            G = (C - B * 65536) \ 256
            R = C - B * 65536 - G * 256
            For K = 0 To 15
                With P16(K)
                     If B = .pBlue And G = .pGreen And R = .pRed Then
                        Idx2 = K
                        Exit For
                     End If
                End With
            Next
            Put #F, , CreateByte(Idx1, Idx2)
        Next
    Next

End Sub
Private Sub Add256ColorData(Pic As PictureBox, F%)

    Dim Dc&, K%
    Dim C&
    Dim Dx%, Dy%
    Dim pW%, pH%
    Dim R&, G&, B&
    Dim Idx As Byte

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    For Dy = pH To 0 Step -1
        For Dx = 0 To pW
            C = GetPixel(Dc, Dx, Dy)
            If C = 0 Then
               Idx = 0
            ElseIf C = &HFFFFFF Then
               Idx = 255
            Else
               B = C \ 65536
               G = (C - B * 65536) \ 256
               R = C - B * 65536 - G * 256
               For K = 1 To 254
                   With P256(K)
                        If B = .pBlue And G = .pGreen And R = .pRed Then
                           Idx = K
                           Exit For
                        End If
                   End With
               Next
            End If
            Put #F, , Idx
        Next
    Next

End Sub
Private Sub AddTrueColorData(Pic As PictureBox, F%)

    Dim C&, Dc&
    Dim Dx%, Dy%
    Dim pW%, pH%
    Dim R&, G&, B&

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    For Dy = pH To 0 Step -1
        For Dx = 0 To pW
            C = GetPixel(Dc, Dx, Dy)
            B = C \ 65536
            G = (C - B * 65536) \ 256
            R = C - B * 65536 - G * 256
            Put #F, , CByte(B)
            Put #F, , CByte(G)
            Put #F, , CByte(R)
        Next
    Next

End Sub
Private Function CreateByte(Idx1%, Idx2%) As Byte

    Dim K%
    Dim Rv As Byte
    Dim Bs1$, Bs2$

    For K = 1 To 4
        If Idx1 Mod 2 Then Bs1 = "1" & Bs1 Else Bs1 = "0" & Bs1
        Idx1 = Idx1 \ 2
        If Idx2 Mod 2 Then Bs2 = "1" & Bs2 Else Bs2 = "0" & Bs2
        Idx2 = Idx2 \ 2
    Next

    Bs1 = Bs1 & Bs2

    For K = 1 To 8
        If Mid(Bs1, K, 1) = "1" Then Rv = Rv + 2 ^ (8 - K)
    Next

    CreateByte = Rv

End Function
Public Function SaveAsSingleIcon(PicMsk As PictureBox, PicImg As PictureBox, NumColors&, FName$) As Boolean

    Dim F%
    Dim bFileOpen As Boolean
    Dim ID As ICONDIR
    Dim IDE As ICONDIRENTRY
    Dim BIH As BITMAPINFOHEADER

    With ID
        .idReserved = 0
        .idType = 1
        .idCount = 1
    End With

    With IDE
        .bWidth = PicImg.Width
        .bHeight = PicImg.Height
        .bColorCount = 0
        .bReserved = 0
        .wPlanes = 1
         Select Case NumColors
                Case 2
                    .wBitCount = 1
                    .dwBytesInRes = ((((.bWidth + 7) \ 8) + 3) And &HFFFFFFFC) * .bHeight + 8 + 40
               Case 16
                    .wBitCount = 4
                    .dwBytesInRes = ((((.bWidth + 1) \ 2) + 3) And &HFFFFFFFC) * .bHeight + 64 + 40
              Case 256
                    .wBitCount = 8
                    .dwBytesInRes = ((.bWidth + 3) And &HFFFFFFFC) * .bHeight + 1024 + 40
             Case Else
                    .wBitCount = 24
                    .dwBytesInRes = ((.bWidth * 3 + 3) And &HFFFFFFFC) * .bHeight + 40
        End Select
        Select Case .bWidth
               Case 16: .dwBytesInRes = .dwBytesInRes + 64
               Case 32: .dwBytesInRes = .dwBytesInRes + 128
               Case 48: .dwBytesInRes = .dwBytesInRes + 384
        End Select
       .dwImageOffset = 22
    End With

    With BIH
        .biSize = Len(BIH)
        .biWidth = PicImg.Width
        .biHeight = PicImg.Height * 2
        .biPlanes = 1
        .biBitCount = IDE.wBitCount
        .biCompression = 0
        .biSizeImage = 0
        .biXPelsPerMeter = 0
        .biYPelsPerMeter = 0
        .biClrUsed = 0
        .biClrImportant = 0
    End With

    On Error Resume Next
       Kill FName
       If Err.Number Then Err.Clear
    On Error GoTo 0

    On Error GoTo SaveSingleIconError
       F = FreeFile
       Open FName For Binary Access Write As #F
            bFileOpen = True
            Put #F, , ID
            Put #F, , IDE
            Put #F, , BIH
            Select Case NumColors
                   Case 2
                        Put #F, , MP()
                        AddMonochromeData PicImg, F
                   Case 16
                        Put #F, , P16()
                        Add16ColorData PicImg, F
                   Case 256
                        Create256PaletteForIconOrCursor PicImg
                        Put #F, , P256()
                        Add256ColorData PicImg, F
                   Case Else
                        AddTrueColorData PicImg, F
            End Select
            AddMonochromeData PicMsk, F
       Close #F
       bFileOpen = False
    On Error GoTo 0

    SaveAsSingleIcon = True
    Exit Function

SaveSingleIconError:

    Err.Clear
    If bFileOpen Then Close #F
    SaveAsSingleIcon = False
    Exit Function

End Function
Public Function SaveAsCursor(PicMsk As PictureBox, PicImg As PictureBox, NumColors&, FName$) As Boolean

    Dim F%
    Dim bFileOpen As Boolean
    Dim CD As CURSORDIR
    Dim CDE As CURSORDIRENTRY
    Dim BIH As BITMAPINFOHEADER

    With CD
        .cdReserved = 0
        .cdType = 2
        .cdCount = 1
    End With

    With CDE
        .bWidth = PicImg.Width
        .bHeight = PicImg.Height
        .bColorCount = 0
        .bReserved = 0
        .wXHotspot = HotX
        .wYHotspot = HotY
         Select Case NumColors
                Case 2
                    .dwBytesInRes = ((((.bWidth + 7) \ 8) + 3) And &HFFFFFFFC) * .bHeight + 8 + 40
               Case 16
                    .dwBytesInRes = ((((.bWidth + 1) \ 2) + 3) And &HFFFFFFFC) * .bHeight + 64 + 40
              Case 256
                    .dwBytesInRes = ((.bWidth + 3) And &HFFFFFFFC) * .bHeight + 1024 + 40
             Case Else
                    .dwBytesInRes = ((.bWidth * 3 + 3) And &HFFFFFFFC) * .bHeight + 40
        End Select
        Select Case .bWidth
               Case 16: .dwBytesInRes = .dwBytesInRes + 64
               Case 32: .dwBytesInRes = .dwBytesInRes + 128
               Case 48: .dwBytesInRes = .dwBytesInRes + 384
        End Select
       .dwImageOffset = 22
    End With

    With BIH
        .biSize = Len(BIH)
        .biWidth = PicImg.Width
        .biHeight = PicImg.Height * 2
        .biPlanes = 1
         Select Case NumColors
                Case 2: .biBitCount = 1
               Case 16: .biBitCount = 4
              Case 256: .biBitCount = 8
             Case Else: .biBitCount = 24
         End Select
        .biCompression = 0
        .biSizeImage = 0
        .biXPelsPerMeter = 0
        .biYPelsPerMeter = 0
        .biClrUsed = 0
        .biClrImportant = 0
    End With

    On Error Resume Next
       Kill FName
       If Err.Number Then Err.Clear
    On Error GoTo 0

    On Error GoTo SaveCursorError
       F = FreeFile
       Open FName For Binary Access Write As #F
            bFileOpen = True
            Put #F, , CD
            Put #F, , CDE
            Put #F, , BIH
            Select Case NumColors
                   Case 2
                        Put #F, , MP()
                        AddMonochromeData PicImg, F
                   Case 16
                        Put #F, , P16()
                        Add16ColorData PicImg, F
                   Case 256
                        Create256PaletteForIconOrCursor PicImg
                        Put #F, , P256()
                        Add256ColorData PicImg, F
                   Case Else
                        AddTrueColorData PicImg, F
            End Select
            AddMonochromeData PicMsk, F
       Close #F
       bFileOpen = False
    On Error GoTo 0

    SaveAsCursor = True
    Exit Function

SaveCursorError:

    Err.Clear
    If bFileOpen Then Close #F
    SaveAsCursor = False
    Exit Function

End Function
Public Function SaveBackToResource(PicMsk As PictureBox, PicImg As PictureBox, NumColors&, OrigFile$, NewFile$) As Boolean

    Dim K&, Idx%, P&, N&
    Dim Fold%, Fnew%
    Dim TempBytesInRes&
    Dim TempBitCount%
    Dim bFileOpen1 As Boolean
    Dim bFileOpen2 As Boolean
    Dim ID As ICONDIR
    Dim IDE As ICONDIRENTRY
    Dim BIH As BITMAPINFOHEADER
    Dim ResData() As Byte
    Dim Offset&, mX&

    On Error Resume Next
       Kill TempFile
       Kill NewFile
       If Err.Number Then Err.Clear
    On Error GoTo 0

    On Error GoTo SaveToResourceError
       Fold = FreeFile
       Open OrigFile For Binary Access Read As #Fold
       bFileOpen1 = True

       If NewFile = "" Then
          Fnew = FreeFile
          Open TempFile For Binary Access Write As #Fnew
          bFileOpen2 = True
       Else
          Fnew = FreeFile
          Open NewFile For Binary Access Write As #Fnew
          bFileOpen2 = True
       End If

       Get #Fold, 1, ID
       Put #Fnew, , ID
       mX = ID.idCount - 1

       With IDE
           .bWidth = IRI.irWidth
           .bHeight = IRI.irHeight
           .bColorCount = 0
           .bReserved = 0
           .wPlanes = 1
            Select Case NumColors
                   Case 2
                       .wBitCount = 1
                       .dwBytesInRes = ((((.bWidth + 7) \ 8) + 3) And &HFFFFFFFC) * .bHeight + 8 + 40
                   Case 16
                       .wBitCount = 4
                       .dwBytesInRes = ((((.bWidth + 1) \ 2) + 3) And &HFFFFFFFC) * .bHeight + 64 + 40
                   Case 256
                       .wBitCount = 8
                       .dwBytesInRes = ((.bWidth + 3) And &HFFFFFFFC) * .bHeight + 1024 + 40
                   Case Else
                       .wBitCount = 24
                       .dwBytesInRes = ((.bWidth * 3 + 3) And &HFFFFFFFC) * .bHeight + 40
            End Select
            Select Case .bWidth
                   Case 16: .dwBytesInRes = .dwBytesInRes + 64
                   Case 32: .dwBytesInRes = .dwBytesInRes + 128
                   Case 48: .dwBytesInRes = .dwBytesInRes + 384
            End Select
            TempBytesInRes = .dwBytesInRes
            TempBitCount = .wBitCount
           .dwImageOffset = 6 + ID.idCount * 16
       End With

       Put #Fnew, , IDE
       Idx = IRI.irIndex

       P = 7
       For K = 0 To mX
           If K <> Idx Then
              Get #Fold, P, IDE
              Put #Fnew, , IDE
           End If
           P = P + 16
       Next

       With BIH
           .biSize = Len(BIH)
           .biWidth = PicImg.Width
           .biHeight = PicImg.Height * 2
           .biPlanes = 1
           .biBitCount = TempBitCount
           .biCompression = 0
           .biSizeImage = TempBytesInRes
           .biXPelsPerMeter = 0
           .biYPelsPerMeter = 0
           .biClrUsed = 0
           .biClrImportant = 0
       End With

       Put #Fnew, , BIH

       Select Case NumColors
              Case 2
                   Put #Fnew, , MP()
                   AddMonochromeData PicImg, Fnew
              Case 16
                   Put #Fnew, , P16()
                   Add16ColorData PicImg, Fnew
              Case 256
                   Create256PaletteForIconOrCursor PicImg
                   Put #Fnew, , P256()
                   Add256ColorData PicImg, Fnew
              Case Else
                   AddTrueColorData PicImg, Fnew
       End Select
       AddMonochromeData PicMsk, Fnew

       P = 7
       For K = 0 To mX
           If K <> Idx Then
              Get #Fold, P, IDE
              ReDim ResData(IDE.dwBytesInRes - 1)
              Get #Fold, IDE.dwImageOffset + 1, ResData()
              Put #Fnew, , ResData()
           End If
           P = P + 16
       Next
 
       N = 35
       P = 7
       Offset = 6 + (ID.idCount * 16) + TempBytesInRes
       For K = 0 To mX
           If K <> Idx Then
              Put #Fnew, N, Offset
              Get #Fold, P, IDE
              Offset = Offset + IDE.dwBytesInRes
              N = N + 16
           End If
           P = P + 16
       Next

       Close #Fold
       bFileOpen1 = False
       Close #Fnew
       bFileOpen2 = False

       If NewFile = "" Then
          On Error Resume Next
             Kill OrigFile
             If Err.Number Then Err.Clear
          On Error GoTo 0
          Name TempFile As OrigFile
          On Error Resume Next
             Kill TempFile
             If Err.Number Then Err.Clear
          On Error GoTo 0
       End If
    On Error GoTo 0

    SaveBackToResource = True
    Exit Function

SaveToResourceError:

    MsgBox Err.Description
    Err.Clear

    If bFileOpen1 Then Close #Fold
    If bFileOpen2 Then Close #Fnew

    On Error Resume Next
       Kill TempFile
       If Err.Number Then Err.Clear
    On Error GoTo 0

    SaveBackToResource = False
    Exit Function

End Function
