Attribute VB_Name = "ModPalette"
Option Explicit
Public Sub PrepPalettes()

    MP(0).pBlue = 0
    MP(0).pGreen = 0
    MP(0).pRed = 0

    MP(1).pBlue = 255
    MP(1).pGreen = 255
    MP(1).pRed = 255

    P16(0).pBlue = 0
    P16(0).pGreen = 0
    P16(0).pRed = 0

    P16(1).pBlue = 0
    P16(1).pGreen = 0
    P16(1).pRed = 128

    P16(2).pBlue = 0
    P16(2).pGreen = 128
    P16(2).pRed = 0

    P16(3).pBlue = 0
    P16(3).pGreen = 128
    P16(3).pRed = 128

    P16(4).pBlue = 128
    P16(4).pGreen = 0
    P16(4).pRed = 0

    P16(5).pBlue = 128
    P16(5).pGreen = 0
    P16(5).pRed = 128

    P16(6).pBlue = 128
    P16(6).pGreen = 128
    P16(6).pRed = 0

    P16(7).pBlue = 192
    P16(7).pGreen = 192
    P16(7).pRed = 192

    P16(8).pBlue = 128
    P16(8).pGreen = 128
    P16(8).pRed = 128

    P16(9).pBlue = 0
    P16(9).pGreen = 0
    P16(9).pRed = 255

    P16(10).pBlue = 0
    P16(10).pGreen = 255
    P16(10).pRed = 0

    P16(11).pBlue = 0
    P16(11).pGreen = 255
    P16(11).pRed = 255

    P16(12).pBlue = 255
    P16(12).pGreen = 0
    P16(12).pRed = 0

    P16(13).pBlue = 255
    P16(13).pGreen = 0
    P16(13).pRed = 255

    P16(14).pBlue = 255
    P16(14).pGreen = 255
    P16(14).pRed = 0

    P16(15).pBlue = 255
    P16(15).pGreen = 255
    P16(15).pRed = 255

End Sub
Public Sub CreateMainPalette()

    Dim H!
    Dim Dc&
    Dim R&, G&, B&
    Dim W&, L!, Hght%

    Dc = FrmMicroArt.PicPal.hDC

    For H = 0 To 334
        L = 0
        For W = 0 To 50
            HLSToRGB H / 66.8, L, 1, R, G, B
            SetPixelV Dc, W, Hght, RGB(R, G, B)
            L = L + 0.02
        Next
        Hght = Hght + 1
    Next

    FrmMicroArt.PicPal.Refresh

End Sub
Public Sub HLSToRGB(ByVal H!, ByVal L!, ByVal S!, R&, G&, B&)

    Dim sMin!, sMax!
    Dim rR!, rG!, rB!

    If S = 0 Then
       rR = L
       rG = L
       rB = L
    Else
       If L <= 0.5 Then sMin = L * (1 - S) Else sMin = L - S * (1 - L)
       sMax = 2 * L - sMin
       
       If H < 1 Then
          rR = sMax
          If H < 0 Then
             rG = sMin
             rB = rG - H * (sMax - sMin)
          Else
             rB = sMin
             rG = H * (sMax - sMin) + rB
          End If
       ElseIf H < 3 Then
          rG = sMax
          If H < 2 Then
             rB = sMin
             rR = rB - (H - 2) * (sMax - sMin)
          Else
             rR = sMin
             rB = (H - 2) * (sMax - sMin) + rR
          End If
       Else
          rB = sMax
          If H < 4 Then
             rR = sMin
             rG = rR - (H - 4) * (sMax - sMin)
          Else
             rG = sMin
             rR = (H - 4) * (sMax - sMin) + rG
          End If
       End If
    End If

    R = rR * 255
    G = rG * 255
    B = rB * 255

End Sub
Public Function GetNumColors&(Pic As PictureBox, bIconOrCursor As Boolean)

    Dim Dc&, pW%, pH%

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    If IsMonochrome(Dc, pW, pH) Then
       GetNumColors = 2
       Exit Function
    End If

    If Is16Color(Dc, pW, pH) Then
       GetNumColors = 16
       Exit Function
    End If

    If bIconOrCursor Then
       If Is256ColorIconOrCursor(Dc, pW, pH) Then
          GetNumColors = 256
          Exit Function
       End If
    Else
       If Is256Color(Dc, pW, pH) Then
          GetNumColors = 256
          Exit Function
       End If
    End If

    GetNumColors = -1

End Function
Private Function IsMonochrome(Dc&, W%, H%) As Boolean

    Dim Dx%, Dy%

    For Dy = 0 To H
        For Dx = 0 To W
            Select Case GetPixel(Dc, Dx, Dy)
                   Case &H0&
                   Case &HFFFFFF
                   Case Else
                        Exit Function
            End Select
        Next
    Next

    IsMonochrome = True

End Function
Private Function Is16Color(Dc&, W%, H%) As Boolean

    Dim Dx%, Dy%

    For Dy = 0 To H
        For Dx = 0 To W
            Select Case GetPixel(Dc, Dx, Dy)
                   Case &H0&
                   Case &H800000
                   Case &H8000&
                   Case &H808000
                   Case &H80&
                   Case &H800080
                   Case &H8080&
                   Case &HC0C0C0
                   Case &H808080
                   Case &HFF0000
                   Case &HFF00&
                   Case &HFFFF00
                   Case &HFF&
                   Case &HFF00FF
                   Case &HFFFF&
                   Case &HFFFFFF
                   Case Else
                        Exit Function
            End Select
        Next
    Next

    Is16Color = True

End Function
Private Function Is256Color(Dc&, W%, H%) As Boolean

    Dim C&
    Dim K%, Sum&
    Dim Clrs&(255)
    Dim Dx%, Dy%
    Dim bFound As Boolean

    Clrs(0) = -1

    For Dy = 0 To H
        For Dx = 0 To W
            C = GetPixel(Dc, Dx, Dy)
            If Clrs(0) = -1 Then
               Clrs(0) = C
            Else
               For K = 0 To Sum - 1
                   If C = Clrs(K) Then
                      bFound = True
                      Exit For
                   End If
               Next
            End If
            If bFound Then
               bFound = False
            Else
               Sum = Sum + 1
               If Sum > 256 Then Exit Function
               Clrs(Sum - 1) = C
            End If
        Next
    Next

    Is256Color = True

End Function
Private Function Is256ColorIconOrCursor(Dc&, W%, H%) As Boolean

    Dim C&, N%
    Dim K%, Sum&
    Dim Clrs&(255)
    Dim Dx%, Dy%
    Dim bFound As Boolean

    N = -1
    Sum = 2
    Clrs(0) = 0
    Clrs(255) = &HFFFFFF

    For Dy = 0 To H
        For Dx = 0 To W
            C = GetPixel(Dc, Dx, Dy)
            If C > 0 And C < &HFFFFFF Then
               If N = -1 Then
                  N = 0
                  Clrs(1) = C
               Else
                  For K = 1 To Sum - 2
                      If C = Clrs(K) Then
                         bFound = True
                         Exit For
                      End If
                  Next
               End If
               If bFound Then
                  bFound = False
               Else
                  Sum = Sum + 1
                  If Sum > 256 Then Exit Function
                  Clrs(Sum - 2) = C
               End If
            End If
        Next
    Next

    Is256ColorIconOrCursor = True

End Function
Public Sub Create256PaletteForBitmap(Pic As PictureBox)

    Dim C&, Dc&
    Dim K%, Sum&
    Dim Clrs&(255)
    Dim Dx%, Dy%
    Dim pW%, pH%
    Dim R&, G&, B&
    Dim bFound As Boolean

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    Clrs(0) = -1
    Erase P256

    For Dy = 0 To pH
        For Dx = 0 To pW
            C = GetPixel(Dc, Dx, Dy)
            If Clrs(0) = -1 Then
               Clrs(0) = C
               B = C \ 65536
               G = (C - B * 65536) \ 256
               R = C - B * 65536 - G * 256
               P256(0).pBlue = B
               P256(0).pGreen = G
               P256(0).pRed = R
            Else
               For K = 0 To Sum - 1
                   If C = Clrs(K) Then
                      bFound = True
                      Exit For
                   End If
               Next
            End If
            If bFound Then
               bFound = False
            Else
               Sum = Sum + 1
               If Sum > 256 Then Exit Sub
               Clrs(Sum - 1) = C
               B = C \ 65536
               G = (C - B * 65536) \ 256
               R = C - B * 65536 - G * 256
               P256(Sum - 1).pBlue = B
               P256(Sum - 1).pGreen = G
               P256(Sum - 1).pRed = R
            End If
        Next
    Next

End Sub
Public Sub Create256PaletteForIconOrCursor(Pic As PictureBox)

    Dim C&, Dc&, N%
    Dim K%, Sum&
    Dim Clrs&(255)
    Dim Dx%, Dy%
    Dim pW%, pH%
    Dim R&, G&, B&
    Dim bFound As Boolean

    With Pic
         Dc = .hDC
         pW = .Width - 1
         pH = .Height - 1
    End With

    N = -1
    Sum = 2
    Clrs(0) = 0
    Clrs(255) = &HFFFFFF
    Erase P256

    With P256(0)
        .pRed = 0
        .pGreen = 0
        .pBlue = 0
    End With

    With P256(255)
        .pRed = 255
        .pGreen = 255
        .pBlue = 255
    End With

    For Dy = 0 To pH
        For Dx = 0 To pW
            C = GetPixel(Dc, Dx, Dy)
            If C > 0 And C < &HFFFFFF Then
               If N = -1 Then
                  N = 0
               Else
                  For K = 0 To Sum - 2
                      If C = Clrs(K) Then
                         bFound = True
                         Exit For
                      End If
                  Next
               End If
               If bFound Then
                  bFound = False
               Else
                  Sum = Sum + 1
                  If Sum > 256 Then Exit Sub
                  Clrs(Sum - 2) = C
                  B = C \ 65536
                  G = (C - B * 65536) \ 256
                  R = C - B * 65536 - G * 256
                  P256(Sum - 2).pBlue = B
                  P256(Sum - 2).pGreen = G
                  P256(Sum - 2).pRed = R
               End If
            End If
        Next
    Next

End Sub
