Attribute VB_Name = "ModRegistry"
Option Explicit

Type SECURITY_ATTRIBUTES
     nLength As Long
     lpSecurityDescriptor As Long
     bInheritHandle As Long
End Type

Declare Function RegCloseKey& Lib "advapi32.dll" (ByVal hKey&)
Declare Function RegCreateKeyEx& Lib "advapi32.dll" Alias "RegCreateKeyExA" (ByVal hKey&, ByVal lpSubKey$, ByVal Reserved&, ByVal lpClass$, ByVal dwOptions&, ByVal samDesired&, lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult&, lpdwDisposition&)
Declare Function RegDeleteValue& Lib "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey&, ByVal lpValueName$)
Declare Function RegOpenKeyEx& Lib "advapi32.dll" Alias "RegOpenKeyExA" (ByVal hKey&, ByVal lpSubKey$, ByVal ulOptions&, ByVal samDesired&, phkResult&)
Declare Function RegQueryValueEx& Lib "advapi32.dll" Alias "RegQueryValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal lpReserved&, lpType&, ByVal lpData$, lpcbData&)
Declare Function RegSetValueEx& Lib "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey&, ByVal lpValueName$, ByVal Reserved&, ByVal dwType&, ByVal lpData$, ByVal cbData&)

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const KEY_ALL_ACCESS = &HF003F
Public Sub SetUpIconDblClick()

    Dim RegData$, hKey&, Rv&
    Dim SA As SECURITY_ATTRIBUTES

    With SA
        .bInheritHandle = True
        .lpSecurityDescriptor = 0
        .nLength = Len(SA)
    End With

    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, ".ico", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, "icofile", 7
       RegCloseKey hKey
    End If

    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, "icofile", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, "Windows Icon", 12
       RegCloseKey hKey
    End If

    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, "icofile\DefaultIcon", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, "%1", 2
       RegCloseKey hKey
    End If

    If Right(App.Path, 1) = "\" Then
       RegData = App.Path & "MicroArt.exe %1"
    Else
       RegData = App.Path & "\MicroArt.exe %1"
    End If

    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, "icofile\Shell\Open\Command", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, RegData, Len(RegData)
       RegCloseKey hKey
    End If

End Sub
Public Sub GetRecentFileList(MRec As Object)

    Dim K%, Pos%, N%
    Dim Buffer$, hKey&, Rv&

    N = 1

    Rv = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\MicroArt\Recent Files", 0, KEY_ALL_ACCESS, hKey)
    If Rv = 0 Then
       For K = 1 To 4
           Buffer = Space(MAX_PATH)
           Rv = RegQueryValueEx(hKey, CStr(K) & ".", 0, 0, Buffer, MAX_PATH)
           Pos = InStr(Buffer, vbNullChar)
           If Pos <> 0 Then
              MRec(0).Visible = 1
              MRec(N).Tag = Left(Buffer, Pos - 1)
              MRec(N).Caption = "&" & CStr(N) & " " & GetTitle(MRec(N).Tag)
              MRec(N).Visible = 1
              N = N + 1
           End If
           RegDeleteValue hKey, CStr(K) & "."
       Next
       RegCloseKey hKey
    End If

End Sub
Public Sub SaveRecentFileList(MRec As Object)

    Dim StrVal$, K%, hKey&, Rv&
    Dim SA As SECURITY_ATTRIBUTES

    SA.bInheritHandle = True
    SA.lpSecurityDescriptor = 0
    SA.nLength = Len(SA)

    Rv = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\MicroArt\Recent Files", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       For K = 1 To 4
           StrVal = MRec(K).Tag
           If StrVal = "" Then
              Exit For
           Else
              RegSetValueEx hKey, CStr(K) & ".", 0, 1, StrVal, Len(StrVal)
           End If
       Next
       RegCloseKey hKey
    End If

End Sub
Public Sub GetLastDir()

    Dim Buffer$, hKey&, Rv&

    ChDrive Left(App.Path, 3)
    ChDir App.Path

    Rv = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\MicroArt\Recent Folder", 0, KEY_ALL_ACCESS, hKey)
    If Rv = 0 Then
       Buffer = Space(MAX_PATH)
       Rv = RegQueryValueEx(hKey, "Folder", 0, 0, Buffer, MAX_PATH)
       If Rv = 0 Then
          On Error Resume Next
             Buffer = Left(Buffer, InStr(Buffer, vbNullChar) - 1)
             ChDrive Left(Buffer, 3)
             ChDir Buffer
             If Err.Number Then Err.Clear
          On Error GoTo 0
       End If
       RegDeleteValue hKey, "Folder"
       RegCloseKey hKey
    End If

End Sub
Public Sub SaveLastDir()

    Dim hKey&, Rv&, Folder$
    Dim SA As SECURITY_ATTRIBUTES

    SA.bInheritHandle = True
    SA.lpSecurityDescriptor = 0
    SA.nLength = Len(SA)

    Rv = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\MicroArt\Recent Folder", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       Folder = CurDir
       RegSetValueEx hKey, "Folder", 0, 1, Folder, Len(Folder)
       RegCloseKey hKey
    End If

End Sub
